type Query {
  me: User!
  users(ids: [ID!]!): [User!]!
  allUsers(
    connection: ConnectionInput
    filter: FilterUserInput
  ): UserConnection!
  findUser(email: String!): User
}

type Mutation {
  connect(input: ConnectInput!): ConnectPayload!
  disconnect: Boolean!
  updateMe(input: UpdateMeInput!): User!
  updateUser(input: UpdateUserInput!): User!
}

type ConnectPayload {
  token: String!
  isNew: Boolean!
  user: User!
}

input ConnectInput {
  email: String! @constraint(format: "email")
  "default:true"
  useCookie: Boolean
}

input UpdateMeInput {
  name: String

  addFollow: ID
  removeFollow: ID
}

type User implements Node {
  id: ID!
  email: String!
  name: String
  enabled: Boolean
  createdAt: DateTime!
  updatedAt: DateTime

  follows(connection: ConnectionInput, filter: FilterUserInput): UserConnection
  followers(
    connection: ConnectionInput
    filter: FilterUserInput
  ): UserConnection
}

input UpdateUserInput {
  id: ID!
  name: String
  enabled: Boolean
}

input FilterUserInput {
  "default:true"
  enabled: Boolean
}

type UserConnection {
  edges: [UserEdge!]!
  pageInfo: PageInfo!
  totalCount: Int!
}

type UserEdge {
  cursor: String!
  node: User!
}
